diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/psap2/Makefile isode-8.0/psap2/Makefile
--- old/isode-8.0/psap2/Makefile	Tue Jun 16 13:29:43 1992
+++ isode-8.0/psap2/Makefile	Tue Aug 24 11:52:20 1993
@@ -68,6 +68,18 @@
 
 inst-libpsap2:	$(LIBDIR)libpsap2.a $(LINTDIR)llib-lpsap2
 
+zap-psap2:
+		-rm -f $(OFILES) libpsap2.a PS_tables.o psap2vrsn.o
+
+linux-lib:	zap-psap2 ../jump/libpsap2.a
+
+../jump/libpsap2.a:	libpsap2.a
+		-rm -f $@
+		cp libpsap2.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libpsap2.a:	libpsap2.a
 		-rm -f $@
 		cp libpsap2.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/psap2-lpp/Makefile isode-8.0/psap2-lpp/Makefile
--- old/isode-8.0/psap2-lpp/Makefile	Tue Jun 16 13:31:58 1992
+++ isode-8.0/psap2-lpp/Makefile	Fri Aug 27 11:04:05 1993
@@ -66,6 +66,18 @@
 
 inst-libpsap2:	$(LIBDIR)libpsap2-lpp.a $(LINTDIR)llib-lpsap2-lpp
 
+zap-psap2-lpp:
+		-rm -f $(OFILES) libpsap2.a PS_tables.o psap2vrsn.o
+
+linux-lib:	zap-psap2-lpp ../jump/libpsap2-lpp.a
+
+../jump/libpsap2-lpp.a:	libpsap2-lpp.a
+		-rm -f $@
+		cp libpsap2-lpp.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libpsap2-lpp.a:	libpsap2-lpp.a
 		-rm -f $@
 		cp libpsap2-lpp.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/quipu/Makefile isode-8.0/quipu/Makefile
--- old/isode-8.0/quipu/Makefile	Tue Jun 16 13:34:01 1992
+++ isode-8.0/quipu/Makefile	Mon Aug 23 11:24:13 1993
@@ -37,8 +37,8 @@
 
 # Remove these two definitions if you do not want the QUIPU optimised malloc.
 # Performace may suffer if you do!
-MALLOC_C =	malloc.c
-MALLOC_O =	malloc.o
+#MALLOC_C =	malloc.c
+#MALLOC_O =	malloc.o
 #DEBUGLIB  =	/xtel/user/cjr/src/mprof/libc_mp.a
 
 ##############################################################
@@ -133,7 +133,7 @@
 		$(LDCC) $(LDFLAGS) -o $@ malloc_test.o qmalloc.o
 
 qmalloc.o:	malloc.c
-		$(CC) $(CFLAGS) -DMALLOC_TEST -o $@ -c malloc.c 
+		$(CC) $(CFLAGS) -o $@ -c malloc.c 
 
 quipuvrsn.c:	$(OFILES)
 		@$(UTILDIR)version.sh quipu > $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/quipu/dish/Makefile isode-8.0/quipu/dish/Makefile
--- old/isode-8.0/quipu/dish/Makefile	Tue Jun 16 13:35:40 1992
+++ isode-8.0/quipu/dish/Makefile	Mon Aug 23 15:52:33 1993
@@ -78,6 +78,7 @@
 		-@echo ""
 
 dish:		xdish
+		:
 
 xdish:		libdish.a dish.o $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ dish.o $(LIBDISH) \
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/quipu/dish/dishlib.c isode-8.0/quipu/dish/dishlib.c
--- old/isode-8.0/quipu/dish/dishlib.c	Tue Jun 16 13:35:46 1992
+++ isode-8.0/quipu/dish/dishlib.c	Fri Aug 20 11:20:34 1993
@@ -160,9 +160,13 @@
 	(void) signal (SIGHUP,	dish_quit);
 	(void) signal (SIGQUIT,	dish_quit);
 	(void) signal (SIGILL, 	dish_quit);
+#ifdef SIGBUS
 	(void) signal (SIGBUS,	dish_quit);
+#endif
 	(void) signal (SIGSEGV,	dish_quit);
+#ifdef SIGSYS
 	(void) signal (SIGSYS,	dish_quit);
+#endif
 	(void) signal (SIGTERM,	dish_quit);
 
 #ifdef TURBO_DISK
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/quipu/dish/fred.c isode-8.0/quipu/dish/fred.c
--- old/isode-8.0/quipu/dish/fred.c	Tue Jun 16 13:35:49 1992
+++ isode-8.0/quipu/dish/fred.c	Fri Aug 20 11:18:39 1993
@@ -137,7 +137,11 @@
 	if (argc != 3)
 	    goto usage;
 
+#ifdef _POSIX_SOURCE
+	(void) setenv ("DISPLAY", argv[2], 1);
+#else
 	(void) setenv ("DISPLAY", argv[2]);
+#endif
 	if (s_photo)
 	    set_av_pe_print (s_photo,
 			     strdup (isodefile ("g3fax/Xphoto", 1)));
@@ -1599,10 +1603,18 @@
 			}
 			ps_print (ps, " ");
 			*--ps -> ps_ptr = NULL, ps -> ps_cnt++;
+#ifdef _POSIX_SOURCE
+			(void) setenv ("RDN", ps -> ps_base, 1);
+#else
 			(void) setenv ("RDN", ps -> ps_base);
+#endif
 		    }
 		    else
+#ifdef _POSIX_SOURCE
+			(void) setenv ("RDN", "Photo", 1);
+#else
 			(void) setenv ("RDN", "Photo");
+#endif
 		}
 		break;
 	    }
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/quipu/dish/pipe.c isode-8.0/quipu/dish/pipe.c
--- old/isode-8.0/quipu/dish/pipe.c	Tue Jun 16 13:35:55 1992
+++ isode-8.0/quipu/dish/pipe.c	Fri Aug 20 11:21:19 1993
@@ -64,7 +64,11 @@
 
 	if ((cp = getenv ("DISHPARENT")) == NULLCP) {
 		(void) sprintf (parent, "%d", getppid ());
+#ifdef _POSIX_SOURCE
+		(void) setenv ("DISHPARENT", cp = parent, 1);
+#else
 		(void) setenv ("DISHPARENT", cp = parent);
+#endif
 	}
 
 
@@ -360,7 +364,11 @@
 #else
 		(void) sprintf (buffer, "127.0.0.1 %d", portno);
 #endif
+#ifdef _POSIX_SOURCE
+		(void) setenv ("DISHPROC", ptr = buffer, 1);
+#else
 		(void) setenv ("DISHPROC", ptr = buffer);
+#endif
 	}
 
 	if ((dp = index (ptr, ' ')) == NULLCP || sscanf (dp + 1, "%d", &portno) != 1) {
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/quipu/dsa.c isode-8.0/quipu/dsa.c
--- old/isode-8.0/quipu/dsa.c	Tue Jun 16 13:34:19 1992
+++ isode-8.0/quipu/dsa.c	Fri Aug 20 11:08:31 1993
@@ -281,9 +281,13 @@
     /* now started don't stop on core dumps !!! */
     (void) signal (SIGQUIT, attempt_restart);
     (void) signal (SIGILL,  attempt_restart);
+#ifdef SIGBUS
     (void) signal (SIGBUS,  attempt_restart);
+#endif
     (void) signal (SIGSEGV, attempt_restart);
+#ifdef SIGSYS
     (void) signal (SIGSYS,  attempt_restart);
+#endif
     (void) signal (SIGPIPE,  attempt_restart);
 #ifdef	SIGUSR1
     (void) signal (SIGUSR1, list_status);
@@ -743,9 +747,13 @@
 
 	(void) signal (SIGQUIT, attempt_restart);
 	(void) signal (SIGILL,  attempt_restart);
+#ifdef SIGBUS
 	(void) signal (SIGBUS,  attempt_restart);
+#endif
 	(void) signal (SIGSEGV, attempt_restart);
+#ifdef SIGSYS
 	(void) signal (SIGSYS,  attempt_restart);
+#endif
 
 	if (sig >= 0 && debug)
 		(void) fprintf (stderr,"DSA %s has a problem\n",mydsaname);
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/quipu/malloc.c isode-8.0/quipu/malloc.c
--- old/isode-8.0/quipu/malloc.c	Tue Jun 16 13:34:31 1992
+++ isode-8.0/quipu/malloc.c	Fri Aug 20 11:11:21 1993
@@ -1,3 +1,5 @@
+#ifndef __linux__
+
 /* malloc.c - Quipu DSA specific memory management */
 
 #ifndef	lint
@@ -804,3 +806,5 @@
 }
 
 #endif	/* QUIPUMALLOC */
+
+#endif /* __linux__ */
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ronot/Makefile isode-8.0/ronot/Makefile
--- old/isode-8.0/ronot/Makefile	Tue Jun 16 13:36:37 1992
+++ isode-8.0/ronot/Makefile	Tue Aug 24 11:51:28 1993
@@ -59,6 +59,18 @@
 
 inst-libronot:	$(LIBDIR)libronot.a $(LINTDIR)llib-lronot
 
+zap-ronot:
+		-rm -f $(OFILES) libronot.a ronotvrsn.o
+
+linux-lib:	zap-ronot ../jump/libronot.a
+
+../jump/libronot.a:	libronot.a
+		-rm -f $@
+		cp libronot.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libronot.a:	libronot.a
 		-rm -f $@
 		cp libronot.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/rosap/Makefile isode-8.0/rosap/Makefile
--- old/isode-8.0/rosap/Makefile	Tue Jun 16 13:37:02 1992
+++ isode-8.0/rosap/Makefile	Wed Aug 25 14:14:43 1993
@@ -78,6 +78,18 @@
 
 inst-librosap:	$(LIBDIR)librosap.a $(LINTDIR)llib-lrosap
 
+zap-rosap:
+		-rm -f $(OFILES) librosap.a ROS_tables.o rosapvrsn.o
+
+linux-lib:	zap-rosap ../jump/librosap.a
+
+../jump/librosap.a:	librosap.a
+		-rm -f $@
+		cp librosap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)librosap.a:	librosap.a
 		-rm -f $@
 		cp librosap.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/rosy/Makefile isode-8.0/rosy/Makefile
--- old/isode-8.0/rosy/Makefile	Tue Jun 16 13:37:29 1992
+++ isode-8.0/rosy/Makefile	Tue Aug 24 11:51:15 1993
@@ -69,6 +69,7 @@
 		-@echo ""
 
 rosy:		xrosy
+		:
 
 xrosy:		rosyvrsn.o $(PEPYLIBES)
 		$(LDCC) $(LDFLAGS) -o $@ rosy.o yacc.o pepy_misc.o \
@@ -133,6 +134,18 @@
 OFILES=		$(P-OFILES) $(N-OFILES) $(OSTRINGS)
 
 inst-librosy:	$(LIBDIR)librosy.a $(LINTDIR)llib-lrosy
+
+zap-rosy:
+		-rm -f $(OFILES) librosy.a
+
+linux-lib:	zap-rosy ../jump/librosy.a
+
+../jump/librosy.a:	librosy.a
+		-rm -f $@
+		cp librosy.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
 
 $(LIBDIR)librosy.a:	librosy.a
 		-rm -f $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/rtsap/Makefile isode-8.0/rtsap/Makefile
--- old/isode-8.0/rtsap/Makefile	Tue Jun 16 13:37:45 1992
+++ isode-8.0/rtsap/Makefile	Tue Aug 24 11:51:56 1993
@@ -73,6 +73,18 @@
 
 inst-librtsap:	$(LIBDIR)librtsap.a $(LINTDIR)llib-lrtsap
 
+zap-rtsap:
+		-rm -f $(OFILES) librtsap.a RTS_tables.o rtsapvrsn.o
+
+linux-lib:	zap-rtsap ../jump/librtsap.a
+
+../jump/librtsap.a:	librtsap.a
+		-rm -f $@
+		cp librtsap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)librtsap.a:	librtsap.a
 		-rm -f $@
 		cp librtsap.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/snmp/snmpd.c isode-8.0/snmp/snmpd.c
--- old/isode-8.0/snmp/snmpd.c	Tue Jun 16 13:38:52 1992
+++ isode-8.0/snmp/snmpd.c	Mon Aug 23 16:00:34 1993
@@ -319,7 +319,9 @@
 			    failed++;
 			    continue;
 			}
+#ifdef FIOCLEX
 			(void) ioctl (udp, FIOCLEX, NULLCP);
+#endif
 			if (udp >= nfds)
 			    nfds = udp + 1;
 			FD_SET (udp, &ifds);
@@ -361,7 +363,9 @@
 			    failed++;
 			    continue;
 			}
+#ifdef FIOCLEX
 			(void) ioctl (clts, FIOCLEX, NULLCP);
+#endif
 			if (clts >= nfds)
 			    nfds = clts + 1;
 			FD_SET (clts, &ifds);
@@ -425,7 +429,9 @@
 	if (smux_enabled) {
 	    if ((smux = start_tcp_server (lsock, SOMAXCONN, 0, 0)) == NOTOK)
 		adios ("failed", "start_tcp_server for SMUX");
+#ifdef FIOCLEX
 	    (void) ioctl (smux, FIOCLEX, NULLCP);
+#endif
 	    if (smux >= nfds)
 		nfds = smux + 1;
 	    FD_SET (smux, &ifds);
@@ -475,7 +481,9 @@
 	if (smux != NOTOK
 		&& FD_ISSET (smux, &rfds)
 	        && (fd = start_smux ()) != NOTOK) {
+#ifdef FIOCLEX
 	    (void) ioctl (fd, FIOCLEX, NULLCP);
+#endif
 	    if (fd >= nfds)
 		nfds = fd + 1;
 	    FD_SET (fd, &ifds);
@@ -494,7 +502,9 @@
 
 #ifdef	COTS
 	if (vecp > 0 && (fd = start_tsap (vecp, vec)) != NOTOK) {
+#ifdef FIOCLEX
 	    (void) ioctl (fd, FIOCLEX, NULLCP);
+#endif
 	    if (fd >= nfds)
 		nfds = fd + 1;
 	    FD_SET (fd, &ifds);
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/ssap/Makefile isode-8.0/ssap/Makefile
--- old/isode-8.0/ssap/Makefile	Tue Jun 16 13:39:41 1992
+++ isode-8.0/ssap/Makefile	Tue Aug 24 11:53:19 1993
@@ -66,6 +66,18 @@
 
 inst-libssap:	$(LIBDIR)libssap.a $(LINTDIR)llib-lssap
 
+zap-ssap:
+		-rm -f $(OFILES) libssap.a ssapvrsn.o
+
+linux-lib:	zap-ssap ../jump/libssap.a
+
+../jump/libssap.a:	libssap.a
+		-rm -f $@
+		cp libssap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libssap.a:	libssap.a
 		-rm -f $@
 		cp libssap.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/support/Makefile isode-8.0/support/Makefile
--- old/isode-8.0/support/Makefile	Tue Jun 16 13:40:09 1992
+++ isode-8.0/support/Makefile	Tue Aug 31 10:54:11 1993
@@ -83,6 +83,7 @@
 		-@echo ""
 
 tsapd:		xtsapd
+		:
 
 xtsapd:		tsapd.o $(TOPDIR)libisode.a
 		$(LDCC) $(LDFLAGS) -o $@ tsapd.o $(LIBISODE) $(LSOCKET)
@@ -103,6 +104,7 @@
 		-@echo ""
 
 iaed:		xiaed
+		:
 
 xiaed:		iaed.o $(TOPDIR)libdsap.a $(TOPDIR)libisode.a
 		$(LDCC) $(LDFLAGS) -o $@ iaed.o \
@@ -140,6 +142,7 @@
 		-@echo ""
 
 isore:		xisore
+		:
 
 xisore:		isore.o
 		$(LDCC) $(LDFLAGS) -o $@ isore.o $(TOPDIR)libcompat.a \
@@ -173,6 +176,7 @@
 		-@echo ""
 
 isod:		xisod
+		:
 
 xisod:		isod.o $(TOPDIR)libisode.a
 		$(LDCC) $(LDFLAGS) -o $@ isod.o $(LIBISODE) $(LSOCKET)
@@ -197,6 +201,7 @@
 		-@echo ""
 
 isoc:		xisoc
+		:
 
 xisoc:		isoc.o $(TOPDIR)libisode.a
 		$(LDCC) $(LDFLAGS) -o $@ isoc.o $(LIBISODE) $(LSOCKET)
@@ -213,6 +218,15 @@
 
 inst-libisode:	$(LIBDIR)libisode.a $(LINTDIR)llib-lisode
 
+zap-vrsn:
+		-rm -f isodevrsn.o
+
+linux-lib:	zap-vrsn ../jump/libisode.a
+
+../jump/libisode.a:	isodevrsn.o
+		ar r $@ isodevrsn.o
+		-@echo ""
+
 $(LIBDIR)libisode.a:	libisode.a
 		@for i in libisode.* ;\
 		do \
@@ -372,8 +386,8 @@
 # lppd
 ################################################################
 
-LPP-LIBES=	$(TOPDIR)libisode-lpp.a
-LPP-LLIBS=	$(TOPDIR)llib-lisode-lpp
+LPP-LIBES=	$(TOPDIR)libpsap2-lpp.a $(TOPDIR)libisode.a
+LPP-LLIBS=	$(TOPDIR)llib-psap2-lpp $(TOPDIR)llib-lisode
 
 inst-lppd:	$(SBINDIR)lppd
 
@@ -385,6 +399,7 @@
 		-@echo ""
 
 lppd:		xlppd
+		:
 
 xlppd:		lppd.o $(LPP-LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ lppd.o $(LPP-LIBES) $(LSOCKET)
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/support/isore.c isode-8.0/support/isore.c
--- old/isode-8.0/support/isore.c	Tue Jun 16 13:40:16 1992
+++ isode-8.0/support/isore.c	Thu Aug 19 16:26:48 1993
@@ -30,6 +30,10 @@
 #include "general.h"
 #include "manifest.h"
 
+#ifndef SIGEMT
+#define SIGEMT	SIGUSR1
+#endif
+
 /*    MAIN */
 
 static SFD	EMTser ();
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/support/tsapd.c isode-8.0/support/tsapd.c
--- old/isode-8.0/support/tsapd.c	Thu Dec  9 17:14:08 1993
+++ isode-8.0/support/tsapd.c	Tue Jun 16 13:40:21 1992
@@ -332,18 +332,9 @@
 		== NULL) {
 #else
     for (is = iae; is < iz; is++)
-	
-#if 0
-	/* THIS doesn't work - JPO */
 	if (tsap_addr_cmp (&is -> is_addr, &ts -> ts_called) == OK)
 	    break;
-#else
-        if (is -> is_addr.ta_selectlen == ts -> ts_called.ta_selectlen
-	    && bcmp (is -> is_addr.ta_selector,
-		     ts -> ts_called.ta_selector,
-		     is -> is_addr.ta_selectlen) == 0)
-	    break;
-#endif
+
     if (is >= iz) {
 #endif
 	    (void) sprintf (buffer, "OSI service tsap/%s not found",
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/tsap/Makefile isode-8.0/tsap/Makefile
--- old/isode-8.0/tsap/Makefile	Tue Jun 16 13:40:41 1992
+++ isode-8.0/tsap/Makefile	Tue Aug 24 11:53:31 1993
@@ -63,6 +63,18 @@
 
 inst-libtsap:	$(LIBDIR)libtsap.a $(LINTDIR)llib-ltsap
 
+zap-tsap:
+		-rm -f $(OFILES) libtsap.a tsapvrsn.o
+
+linux-lib:	zap-tsap ../jump/libtsap.a
+
+../jump/libtsap.a:	libtsap.a
+		-rm -f $@
+		cp libtsap.a $@
+		@$(UTILDIR)make-lib.sh $(SYSTEM) $@ -ranlib
+		-@ls -gls $@
+		-@echo ""
+
 $(LIBDIR)libtsap.a:	libtsap.a
 		-rm -f $@
 		cp libtsap.a $@
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/tsap/ts2tcp.c isode-8.0/tsap/ts2tcp.c
--- old/isode-8.0/tsap/ts2tcp.c	Tue Jun 16 13:40:45 1992
+++ isode-8.0/tsap/ts2tcp.c	Tue Sep 14 10:48:33 1993
@@ -37,7 +37,7 @@
 #ifdef	BSD42
 #include <sys/ioctl.h>
 #endif
-#ifdef	SYS5
+#if defined(SYS5) || defined(__linux__)
 #include <fcntl.h>
 #endif
 
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/tsap/tsaprovider.c isode-8.0/tsap/tsaprovider.c
--- old/isode-8.0/tsap/tsaprovider.c	Tue Jun 16 13:40:51 1992
+++ isode-8.0/tsap/tsaprovider.c	Fri Sep 10 16:06:28 1993
@@ -36,6 +36,9 @@
 #include "sys.file.h"
 #include <sys/stat.h>
 
+#ifdef __linux__
+#include <linux/sockios.h>
+#endif
 
 #define	selmask(fd,m,n) \
 { \
@@ -421,7 +424,7 @@
     register struct TSAPdisconnect *td = &tds;
 
 #ifndef	BSDSIGS
-    (void) signal (SIGEMT, DATAser);
+    (void) signal (_SIGIO, DATAser);
 
     smask = sigioblock ();
 #endif
@@ -472,7 +475,7 @@
     }
 
 #ifndef	SIGPOLL
-    (void) kill (TPid, SIGEMT);
+    (void) kill (TPid, _SIGIO);
 #endif
 
 #ifndef	BSDSIGS
@@ -514,10 +517,10 @@
 	return tsaplose (td, DR_CONGEST, NULLCP, "you lose");
     if (!inited) {
 #ifndef	BSDSIGS
-	int    smask = sigsetmask (sigblock (0) & ~sigmask (SIGEMT));
+	int    smask = sigsetmask (sigblock (0) & ~sigmask (_SIGIO));
 #endif
 
-	(void) signal (SIGEMT, DATAser);
+	(void) signal (_SIGIO, DATAser);
 #ifndef	BSDSIGS
 	(void) sigiomask (smask);
 #endif
@@ -542,7 +545,7 @@
 		continue;
 
 	    case OK: 
-		(void) signal (SIGEMT, SIG_DFL);
+		(void) signal (_SIGIO, SIG_DFL);
 		(void) execv (*is -> is_vec, is -> is_vec);
 		_exit (1);
 
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/util/version.sh isode-8.0/util/version.sh
--- old/isode-8.0/util/version.sh	Tue Jun 16 11:12:10 1992
+++ isode-8.0/util/version.sh	Thu Aug 19 15:39:29 1993
@@ -1,7 +1,7 @@
 : run this script through /bin/sh
 
 : this hacks past a bug in make...
-exec 3<&- 4<&- 5<&- 6<&- 7<&-
+#exec 3<&- 4<&- 5<&- 6<&- 7<&-
 
 OFS="$IFS" IFS=:
 
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/vt/Makefile isode-8.0/vt/Makefile
--- old/isode-8.0/vt/Makefile	Tue Jun 16 13:41:09 1992
+++ isode-8.0/vt/Makefile	Mon Aug 23 15:16:14 1993
@@ -74,6 +74,7 @@
 		-@echo ""
 
 vtd:		xvtd
+		:
 
 xvtd:		vtd.o $(OFILES) libvt.a $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ vtd.o $(OFILES) libvt.a \
@@ -108,6 +109,7 @@
 		-@echo ""
 
 vt:		xvt
+		:
 
 xvt:		vt.o $(OFILES) libvt.a $(LIBES)
 		$(LDCC) $(LDFLAGS) -o $@ vt.o $(OFILES) libvt.a \
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/vt/map.c isode-8.0/vt/map.c
--- old/isode-8.0/vt/map.c	Tue Jun 16 13:41:11 1992
+++ isode-8.0/vt/map.c	Mon Aug 23 14:38:05 1993
@@ -37,7 +37,12 @@
 #include <sys/ioctl.h>
 #endif
 #ifdef TERMIOS
+#ifdef __linux__
+#include <termios.h>
+#include <unistd.h>
+#else
 #include <sys/termios.h>
+#endif
 #endif
 #include <fcntl.h>
 
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/vt/vt.c isode-8.0/vt/vt.c
--- old/isode-8.0/vt/vt.c	Tue Jun 16 13:41:20 1992
+++ isode-8.0/vt/vt.c	Mon Aug 23 14:32:47 1993
@@ -34,7 +34,11 @@
 #include <sys/ioctl.h>
 #endif
 #ifdef TERMIOS
+#ifdef __linux__
+#include <termios.h>
+#else
 #include <sys/termios.h>
+#endif
 #endif
 #include <ctype.h>
 #include <setjmp.h>
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/vt/vtd.c isode-8.0/vt/vtd.c
--- old/isode-8.0/vt/vtd.c	Tue Jun 16 13:41:21 1992
+++ isode-8.0/vt/vtd.c	Fri Aug 27 09:29:56 1993
@@ -36,7 +36,12 @@
 #include <sys/ioctl.h>
 #endif
 #ifdef	TERMIOS
+#ifdef __linux__
+#include <termios.h>
+#include <unistd.h>
+#else
 #include <sys/termios.h>
+#endif
 #ifdef BSD44
 #include <sys/ttydefaults.h>
 #include <sys/stat.h>
@@ -61,13 +66,17 @@
 #include <varargs.h>
 
 #define	BELL	'\07'
-#ifndef	SUNOS4
-#define BANNER	"\r\n\r\n4.2 BSD UNIX (%s)\r\n\r\n\r%s"
-#else
+#ifdef	SUNOS4
 #define BANNER	"\r\n\r\nSunOS UNIX (%s)\r\n\r\n\r%s"
+#else
+#ifdef __linux__
+#define BANNER	"\r\n\r\nLinux (%s)\r\n\r\n\r%s"
+#else
+#define BANNER	"\r\n\r\n4.2 BSD UNIX (%s)\r\n\r\n\r%s"
 #endif
+#endif
 
-#if !defined(SYS5) && !defined(BSD44) && !defined(_AIX)
+#if !defined(SYS5) && !defined(BSD44) && !defined(_AIX) && !defined(__linux__)
 void	vhangup();
 #endif
 
@@ -149,6 +158,9 @@
 #ifndef TERMIOS
 	struct sgttyb b;
 #endif
+#ifdef __linux__
+	struct termios b;
+#endif
 
     if (myname = rindex (*argv, '/'))
 	myname++;
@@ -199,7 +211,7 @@
 	}
 	else
 		exit(1);
-#ifdef TERMIOS
+#if defined(TERMIOS) && !defined(__linux__)
 	na_image = 0;
 	nego_state = 0;			/*Start off in Local echo*/
 	i = forkpty(&p, line, NULL, NULL);
@@ -231,6 +243,9 @@
 gotpty:
 
 	cp[strlen("/dev/")] = 't';
+#ifdef __linux__
+	setsid();
+#else
 	t = open("/dev/tty", 2);
 	if (t >= 0) {
 		if (ioctl(t, TIOCNOTTY, 0) == -1) {
@@ -238,9 +253,24 @@
 		}
 		(void)close(t);
 	}
+#endif
 	t = open(cp, 2);
 	if (t < 0)
 		fatalperror(f, cp, errno);
+#ifdef __linux__
+	if (tcgetattr(t, (char*)&b) == -1) {
+		perror("tcgetattr");
+		adios(NULLCP, "tcgetattr failed");
+	}
+	if (telnet_profile)
+		b.c_lflag &= ~ECHO;
+	else
+		b.c_lflag |= ECHO;	/*Remote echo for Default*/
+	if (tcsetattr(t, TCSAFLUSH, (char*)&b) == -1) {
+		perror("tcsetattr");
+		adios(NULLCP, "tcsetattr failed");
+	}
+#else
 	if (ioctl(t, TIOCGETP, (char*)&b) == -1) {
 		perror("ioctl (TIOCGETP)");
 		adios(NULLCP, "ioctl failed (TIOCGETP)");
@@ -262,6 +292,7 @@
 		perror("ioctl (TIOCSETP)");
 		adios(NULLCP, "ioctl failed (TIOCSETP)");
 	}
+#endif
 	na_image = 0;
 	nego_state = 0;			/*Start off in Local echo*/
 
diff --new-file --recursive --unified --exclude=version.local --exclude=update.* old/isode-8.0/vt/vtd.c isode-8.0/vt/vtd.c
--- old/isode-8.0/quipu/sys_init.c	Tue Jun 16 13:41:21 1992
+++ isode-8.0/quipu/sys_init.c	Fri Aug 27 09:29:56 1993
@@ -107,7 +107,7 @@
 	    && ((statbuf.st_mode & S_IFMT) == S_IFDIR)) {
 		    /* tmpdir exists - clean it */
 		struct dirent **namelist;
-		(void) _scandir(edbtmp_buf, &namelist, rmFiles, NULLIFP);
+		(void) scandir(edbtmp_buf, &namelist, rmFiles, NULLIFP);
 		if (namelist)
 		    free((char *) namelist);
 
That's it. End of patch. If you've actually *read* all that - congratulations!
